<?php 
add_action( 'add_meta_boxes', 'pm_social_add_social_quiz_box' );
function pm_social_add_social_quiz_box() {
	add_meta_box(
		'pm_social_mbox',
		__( 'Questions &amp; Scoring' , 'pm-social-quiz' ),
		'pm_social_social_quiz_box',
		'social_quiz', 'normal' , 'core'
	);
}

function pm_social_social_quiz_box( $post ) {
	wp_enqueue_style( 'pm-social-admin-fa', '//maxcdn.bootstrapcdn.com/font-awesome/4.3.0/css/font-awesome.min.css', '', PM_SOCIAL_QUIZ_VERSION, 'all' );
	wp_enqueue_style( 'pm-social-admin-chosen-style', PM_SOCIAL_QUIZ_DIR.'modules/libs/chosen/chosen.min.css', '', PM_SOCIAL_QUIZ_VERSION, 'all' );
	wp_enqueue_script( 'pm-social-validate','http://ajax.aspnetcdn.com/ajax/jquery.validate/1.14.0/jquery.validate.min.js', array('jquery'), PM_SOCIAL_QUIZ_VERSION, true  );
	wp_enqueue_script('jquery-ui-sortable');
	wp_enqueue_script( 'pm-social-admin-chosen-script', PM_SOCIAL_QUIZ_DIR.'modules/libs/chosen/chosen.jquery.min.js', '', PM_SOCIAL_QUIZ_VERSION );
	wp_enqueue_script( 'pm-social-admin-script', PM_SOCIAL_QUIZ_DIR.'modules/src/js/pm-sq.js', array('jquery'), PM_SOCIAL_QUIZ_VERSION, true );
	wp_enqueue_style( 'pm-social-admin-style',PM_SOCIAL_QUIZ_DIR.'modules/src/css/style-admin.css', '', PM_SOCIAL_QUIZ_VERSION, 'all' );
	wp_nonce_field( plugin_basename( __FILE__ ), 'pm_social_noncename' );
	$entries = get_post_meta($post->ID,'_pm_sq', true);
	$ranges = get_post_meta($post->ID,'_pm_sqr', true);
	$short_description = get_post_meta($post->ID,'_pm_sqa_description', true);
	?>
	<?php  ?>
	<div id="social_quiz_post_meta">
		<h4><?php esc_html(_e('Quiz Short Description ', 'pm-social-quiz')); ?></h4>
		<textarea class="short_description required" name="sqa_description" id="sqa_description"cols="50"><?php print nl2br($short_description); ?></textarea>
		
		<h4><?php esc_html(_e('Select Questions', 'pm-social-quiz')); ?></h4>
		<ol>
			<?php if(!empty($entries)): foreach($entries as $entry): ?>
				<li class="pm_social_label_wrapper">
				<span class="sq_btn btn_drag"><i class="fa fa-plus handle"></i></span> 
					<select name="pm_social_form_data[]" class="pm_social_form_post_id required">
						<?php pm_social_get_post($entry); ?>
					</select>
				<span class="sq_btn btn_remove"><i class="fa fa-minus"></i></span> 
				</li>
			<?php endforeach; 
			else: ?>
			<li class="pm_social_label_wrapper">
			<span class="sq_btn btn_drag"><i class="fa fa-plus handle"></i></span> 
				<select name="pm_social_form_data[]" class="pm_social_form_post_id required">
					<option value="" style="display: none;" default><?php esc_html(_e('Select Post ', 'pm-social-quiz')); ?></option>
					<?php pm_social_get_post(); ?>
				</select>
			<span class="sq_btn btn_remove"><i class="fa fa-minus"></i></span> 				
			</li>
			<?php endif; ?>
		</ol>
		<p><input type="button" id="sq_addquestion" value="<?php esc_html(_e( 'Add Question' , 'pm-social-quiz' )); ?>"></p>
		
		<h4><?php esc_html(_e('Scoring Table', 'pm-social-quiz')); ?></h4>
		<table class="social_questions" border="1">
			<thead>
			<tr>
				<th><?php esc_html(_e( 'Min' , 'pm-social-quiz' )); ?></th>
				<th><?php esc_html(_e( 'Max' , 'pm-social-quiz' )); ?></th>
				<th><?php esc_html(_e( 'Score' , 'pm-social-quiz' )); ?></th>
				<th><?php esc_html(_e( 'Remove' , 'pm-social-quiz' )); ?></th>
			</tr>
			</thead>
			<tbody>
			<?php if(!empty($ranges) ): foreach($ranges as $key => $range): ?>
			<tr class="social_question_wrapper">
				<td><input type="number" class="field sqa_min required" name="sqr[<?php print $key; ?>][min]" value="<?php print $range['min']; ?>" /></td>
				<td><input type="number" class="field sqa_max required" name="sqr[<?php print $key; ?>][max]" value="<?php print $range['max']; ?>" /></td>
				<td><textarea rows="4" cols="40"  type="text" class="field sqa_answer required" name="sqr[<?php print $key; ?>][answer]" ><?php print nl2br($range['answer']); ?> </textarea></td>
				<td><span class="remove"><i class="fa fa-minus"></i> <?php esc_html(_e( 'Remove' , 'pm-social-quiz' )); ?></span></td>
			</tr>
			<?php endforeach; else: ?>
			<tr class="social_question_wrapper">
				<td><input type="number" class="field sqa_min required" name="sqr[1][min]" value="" /></td>
				<td><input type="number" class="field sqa_max required" name="sqr[1][max]" value="" /></td>
				<td><textarea rows="4" cols="40"  type="text" class="field sqa_answer required" name="sqr[1][answer]" ></textarea></td>
				<td><span class="remove"><i class="fa fa-minus"></i> <?php esc_html(_e( 'Remove' , 'pm-social-quiz' )); ?></span></td>
			</tr>
			<?php endif; ?>
			</tbody>
		</table>
		<p><input type="button" id="sq_addrow" value="<?php esc_html(_e( 'Add Range' , 'pm-social-quiz' )); ?>"></p>
		
		
	</div>
	<?php
}

add_action( 'save_post', 'pm_social_social_quiz_box_save_postdata' );
function pm_social_social_quiz_box_save_postdata( $post_id ) {

	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	  return;
	if ( !empty( $_POST['pm_social_noncename'] ) && !wp_verify_nonce( $_POST['pm_social_noncename'], plugin_basename( __FILE__ ) ) )
	  return;
	if ( !empty($_POST['post_type']) && 'page' == $_POST['post_type'] ) 
	{
	if ( !current_user_can( 'edit_page', $post_id ) )
		return;
	}
	else
	{
	if ( !current_user_can( 'edit_post', $post_id ) )
		return;
	}
	//Validate
	
	
	if(isset($_POST['pm_social_form_data']) && !empty($_POST['pm_social_form_data']) ) {
		update_post_meta( $post_id, '_pm_sq', $_POST['pm_social_form_data']);
	}
	
	if(isset($_POST['sqr']) && !empty($_POST['sqr']) ) {
		update_post_meta( $post_id, '_pm_sqr', $_POST['sqr']);
	}
	
	if(isset($_POST['sqa_description']) && !empty($_POST['sqa_description']) ) {
		update_post_meta( $post_id, '_pm_sqa_description', $_POST['sqa_description']);
	}
}

/*
	* POST Meta for Social Questions
	*
	*
*/

add_action( 'add_meta_boxes', 'pm_social_add_social_question_box' );
function pm_social_add_social_question_box() {
	add_meta_box(
		'pm_social_mbox',
		__( 'Answers' , 'pm-social-quiz' ),
		'pm_social_social_question_box',
		'social_question', 'normal' , 'core'
	);
}

function pm_social_social_question_box( $post ) {	
	wp_enqueue_media();
	wp_enqueue_style( 'pm-social-admin-fa', '//maxcdn.bootstrapcdn.com/font-awesome/4.3.0/css/font-awesome.min.css', '', PM_SOCIAL_QUIZ_VERSION, 'all' );
	wp_enqueue_style( 'pm-social-admin-chosen-style', PM_SOCIAL_QUIZ_DIR.'modules/libs/chosen/chosen.min.css', '', PM_SOCIAL_QUIZ_VERSION, 'all' );
	wp_enqueue_script( 'pm-social-validate','http://ajax.aspnetcdn.com/ajax/jquery.validate/1.14.0/jquery.validate.min.js', array('jquery'), PM_SOCIAL_QUIZ_VERSION, true  );
	wp_enqueue_script( 'meta-box-image-upload' );
	wp_enqueue_script('jquery-ui-sortable');
	wp_enqueue_script( 'pm-social-admin-script', PM_SOCIAL_QUIZ_DIR.'modules/src/js/pm-sq.js', array('jquery'), PM_SOCIAL_QUIZ_VERSION, true );
	wp_localize_script( 'pm-social-admin-script', 'meta_image',
		array(
			'title' => 'Choose or Upload an Image',
			'button' => 'Use this image',
		)
	);
	wp_enqueue_style( 'pm-social-admin-style',PM_SOCIAL_QUIZ_DIR.'modules/src/css/style-admin.css', '', PM_SOCIAL_QUIZ_VERSION, 'all' );
	wp_nonce_field( plugin_basename( __FILE__ ), 'pm_social_noncename' );
	$entries = get_post_meta($post->ID,'_pm_sqa', true);
	$qtype = (get_post_meta($post->ID,'_pm_sqa_type', true) ? get_post_meta($post->ID,'_pm_sqa_type', true)  : 'image');
	
	?>
	<div id="social_quiz_post_meta">
		<div class="social_questions_type">
			<input type="radio" name="sqa_type" id="sqa_type_image" class="sqa_type" value="image" <?php print ($qtype == 'image' ? 'checked' : ''); ?>>
			<label for="sqa_type_image"><?php esc_html(_e( 'Image' , 'pm-social-quiz' )); ?></label>
			<br />
			<input type="radio" name="sqa_type" id="sqa_type_text" class="sqa_type" value="text" <?php print ($qtype == 'text' ? 'checked' : ''); ?>>
			<label for="sqa_type_text"><?php esc_html(_e( 'Text' , 'pm-social-quiz' )); ?></label>
			<br />
			<p class="description"><?php esc_html(_e( 'Select the type of answers.' , 'pm-social-quiz' )); ?></p>
		</div>
		<table class="social_questions sortable" border="1">
			<thead>
			<tr>
				<th><?php esc_html(_e( 'Sorting' , 'pm-social-quiz' )); ?></th>
				<th><?php esc_html(_e( 'Answer' , 'pm-social-quiz' )); ?></th>
				<th><?php esc_html(_e( 'Score' , 'pm-social-quiz' )); ?></th>
				<th><?php esc_html(_e( 'Remove Row' , 'pm-social-quiz' )); ?></th>
			</tr>
			</thead>
			<tbody>
			<?php if(empty($entries) ): ?>
			<tr class="social_question_wrapper">
				<td><i class="fa fa-plus handle"></i></td>
				<td>
				<textarea rows="6" cols="60" type="text" class="field sqa_text_answer <?php print ($qtype == 'text' ? 'required' : 'hidden'); ?>" name="sqa[1][text_answer]" ></textarea>
				<input type="hidden" class="field sqa_answer sqa_image_answer <?php print ($qtype == 'image' ? 'required' : 'hidden'); ?>" name="sqa[1][answer]" value="" />
				<input type="button" class="button sqa_imagebtn sqa_image_answer <?php print ($qtype == 'text' ? 'hidden' : ''); ?>" data-btn="sqa[1][answer]" value="Browse or Upload an Image" />
				<img style="display: none;" height="150" class="sqa_answer_preview sqa_image_answer <?php print ($qtype == 'text' ? 'hidden' : ''); ?>" data-name="sqa[1][answer]" src="#" />
				</td>
				<td><input class="field sqa_score required"  type="number" step="1" min="0" max="9999" name="sqa[1][score]"  size="4" /></td>
				<td><span class="remove"><i class="fa fa-minus"></i> <?php esc_html(_e( 'Remove' , 'pm-social-quiz' )); ?></span></td>
			</tr>
			<?php else: ?>
			<?php foreach($entries as $key => $val): ?>
			<tr class="social_question_wrapper">
				<td><i class="fa fa-plus handle"></i></td>
				<?php /*<td><textarea class="sqa_answer" name="sqa[<?php print $key; ?>][answer]" ><?php print nl2br($val['answer']); ?></textarea></td> */ ?>
				<td>
				<textarea rows="6" cols="60" type="text" class="field sqa_text_answer <?php print ($qtype == 'text' ? 'required' : 'hidden'); ?>" name="sqa[<?php print $key; ?>][text_answer]" ><?php print strip_tags($val['text_answer'], '<br><br/>'); ?></textarea>
				<input type="hidden" class="field sqa_answer sqa_image_answer <?php print ($qtype == 'image' ? 'required' : 'hidden'); ?>" name="sqa[<?php print $key; ?>][answer]" value="<?php print $val['answer']; ?>" />
				<input type="button" class="button sqa_imagebtn sqa_image_answer <?php print ($qtype == 'text' ? 'hidden' : ''); ?>" data-btn="sqa[<?php print $key; ?>][answer]" value="Browse or Upload an Image" />
				<img height="150" class="sqa_answer_preview sqa_image_answer <?php print ($qtype == 'text' ? 'hidden' : ''); ?>" data-name="sqa[<?php print $key; ?>][answer]" src="<?php print $val['answer']; ?>" />
				</td>
				<td><input class="field sqa_score required"  type="number" step="1" min="0" max="9999" name="sqa[<?php print $key; ?>][score]" value="<?php print $val['score']; ?>" size="4" /></td>
				<td><span class="remove"><i class="fa fa-minus"></i> <?php esc_html(_e( 'Remove' , 'pm-social-quiz' )); ?></span></td>
			</tr>
			<?php endforeach;?>
			<?php endif; ?>
			</tbody>
		</table>
		<p><input type="button" id="sq_addrow" value="<?php esc_html(_e( 'Add Row' , 'pm-social-quiz' )); ?>"></p>
	</div>
	<?php
}

add_action( 'save_post', 'pm_social_social_question_box_save_postdata' );
function pm_social_social_question_box_save_postdata( $post_id ) {

	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	  return;
	if ( !empty( $_POST['pm_social_noncename'] ) && !wp_verify_nonce( $_POST['pm_social_noncename'], plugin_basename( __FILE__ ) ) )
	  return;
	if ( !empty($_POST['post_type']) && 'page' == $_POST['post_type'] ) 
	{
	if ( !current_user_can( 'edit_page', $post_id ) )
		return;
	}
	else
	{
	if ( !current_user_can( 'edit_post', $post_id ) )
		return;
	}
	
	if(isset($_POST['sqa']) && !empty($_POST['sqa']) ) {
		update_post_meta( $post_id, '_pm_sqa', $_POST['sqa']);
	}
	
	if(isset($_POST['sqa_type']) && !empty($_POST['sqa_type']) ) {
		update_post_meta( $post_id, '_pm_sqa_type', $_POST['sqa_type']);
	}
	
	
	
	
}

?>