<?php 
/*
	* pm_social_adminscripts
	* Enq Scripts and StyleSheets
	* FontAwesome: //maxcdn.bootstrapcdn.com/font-awesome/4.3.0/css/font-awesome.min.css

*/

function pm_social_register_settings() {
	add_submenu_page('edit.php?post_type=social_quiz', esc_html(sprintf(__( '%s ', 'pm-social-quiz' ), PM_SOCIAL_QUIZ_PLUGIN_NAME)), esc_html(__( 'Settings', 'pm-social-quiz' )), 'manage_options', 'pm_social_settings','pm_social_settings_page');
	add_action( 'admin_init', 'pm_social_settings_register_callback' );
}
add_action( 'admin_menu', 'pm_social_register_settings' );


/*
	* pm_social_settings_register_callback
*/

function pm_social_settings_register_callback() {
	//register our settings
	register_setting( 'pm-social-quiz-settings-group', PM_SOCIAL_QUIZ_SETTINGS_OPTION, 'pm_social_settings_validate');
}

/*
	* pm_social_settings_validate
*/

function pm_social_settings_validate($input) {
	foreach($input as $key => $value) {
		if(is_array($input[$key])) {
			$input[$key] = array_filter($input[$key]);
		}
	}
	return $input;
}


/*
	* Settings Page for Social Quiz
*/


function pm_social_settings_page() {
	$options = array('fbapi' => '');
	$options = get_option(PM_SOCIAL_QUIZ_SETTINGS_OPTION);
	?>
	<div class="wrap">
		<h2><?php esc_html(printf(__( '%s Settings', 'pm-social-quiz' ), PM_SOCIAL_QUIZ_PLUGIN_NAME)); ?></h2>
		<form method="post" class="pm_social_quiz_form" action="options.php"> 
			<?php settings_fields( 'pm-social-quiz-settings-group' ); ?>
			<?php do_settings_sections( 'pm-social-quiz-settings-group' ); ?>
			<fieldset>
				<legend><?php esc_html(_e( 'Facebook Settings', 'pm-social-quiz' )); ?></legend>
				<input value="<?php print $options['fbapi']; ?>" type="text" name="<?php print PM_SOCIAL_QUIZ_SETTINGS_OPTION; ?>[fbapi]" id="<?php print PM_SOCIAL_QUIZ_SETTINGS_OPTION; ?>[fbapi]" class="pm_social_quiz_field" /><br />
				<p class="description"><?php esc_html(_e( 'If not empty, this will use Facebook Sharing and Share your quiz Result. If empty it will use the default Facebook Sharing and will share only the quiz excluding result.', 'pm-social-quiz' )); ?></p>
			</fieldset>
			<?php submit_button(); ?>
		</form>
	</div>
	<?php
}