(function( $ ) {
	var $sq_wrapper = jQuery('table.social_questions tr.social_question_wrapper:last-child');
	var $sq_quizzes = jQuery('#social_quiz_post_meta ol li:last-child');
	jQuery.extend(jQuery.validator.messages, {
    required: "Required Field"
	});
	jQuery('body.post-type-social_question #post').validate({
        ignore: []
    });
	
	jQuery('body.post-type-social_quiz #post').validate({
        // any other options and/or rules
		errorPlacement: function(){
            return false;  // suppresses error message text
        }
    });
	
	jQuery('#sq_addrow').live('click', function() {
		var choices = jQuery('table.social_questions .sqa_answer').length;
		$sq_wrapper.clone().appendTo('table.social_questions');
		jQuery('table.social_questions tr:last-child').find('input.field,textarea').each(function() {
		
			jQuery(this).attr('name', function() {this.name = this.name.replace(/[0-9]/, choices + 1);});
			jQuery(this).val('');
		});
		jQuery('table.social_questions tr:last-child').find('input.button').each(function() {
			var next_btn = jQuery(this).attr('data-btn').replace(/[0-9]/, choices + 1);
			jQuery(this).attr('data-btn', next_btn);
		});
		jQuery('table.social_questions tr:last-child').find('img.sqa_answer_preview').each(function() {
			var next_value = jQuery(this).attr('data-name').replace(/[0-9]/, choices + 1);
			jQuery(this).parent().find('img.sqa_answer_preview').attr('data-name', next_value);
			jQuery(this).parent().find('img.sqa_answer_preview').attr('src', '');
		});
	});
	
	// Instantiates the variable that holds the media library frame.
    var meta_image_frame;

    // Runs when the image button is clicked.
	var position = 1;
    jQuery('table.social_questions .button.sqa_imagebtn').live('click',function(e){
        // Prevents the default action from occuring.
        e.preventDefault();
		position = jQuery(this).attr('data-btn');
		

        // If the frame already exists, re-open it.
        if ( meta_image_frame ) {
            meta_image_frame.open();
            return;
        }

        // Sets up the media library frame
        meta_image_frame = wp.media.frames.meta_image_frame = wp.media({
            title: meta_image.title,
            button: { text:  meta_image.button },
            library: { type: 'image' },
			multiple: false
        });
		
		function getUrl() {
			var media_attachment = meta_image_frame.state().get('selection').first().toJSON();
			jQuery('table.social_questions input[name="'+position+'"]').val(media_attachment.url);
			jQuery('table.social_questions img[data-name="'+position+'"]').attr('src', media_attachment.url);
			jQuery('table.social_questions img[data-name="'+position+'"]').show();
		}

        // Runs when an image is selected.
        meta_image_frame.on( "select", getUrl );

        // Opens the media library frame.
        meta_image_frame.open();
    });
	
	/*
		* Delete Rows
	*/
	
	jQuery('table.social_questions tr.social_question_wrapper').find('span.remove').live('click', function(a) {
		a.preventDefault();
		var count = 1;

		jQuery(this).parents('tr').remove();
		sq_reset_rows(count);
	});
	
	var fixHelperModified = function(e, tr) {
		var $originals = tr.children();
		var $helper = tr.clone();
		$helper.children().each(function(index)
		{
		  $(this).width($originals.eq(index).width())
		});
		return $helper;
	};
	jQuery("table.social_questions.sortable tbody").sortable({
		handle: '.handle',
		helper: fixHelperModified ,
	});
	
	/*
		* Add Questions
	*/
	jQuery('#social_quiz_post_meta select.pm_social_form_post_id').each(function() {
		jQuery(this).chosen().trigger('chosen:updated');
	});
	
	jQuery('#sq_addquestion').click(function() {
		$sq_quizzes.clone().appendTo('#social_quiz_post_meta ol');
		jQuery('#social_quiz_post_meta ol li:last-child').find('.chosen-container').remove();
		jQuery('#social_quiz_post_meta ol li:last-child select').css({'display':'block'}).chosen();
		
	});
	jQuery("#social_quiz_post_meta ol").sortable({ handle: '.handle' });
	jQuery('#social_quiz_post_meta ol .btn_remove i').live('click', function(a) {
		a.preventDefault();
		jQuery(this).parents('li').remove();
	});
	//.btn_remove
	
	
	jQuery('#social_quiz_post_meta .social_questions_type input.sqa_type').change(function() {
		var value_type = jQuery(this).val();
		
		if(value_type == 'text') {
			jQuery('#social_quiz_post_meta .social_questions').find('.sqa_image_answer').removeClass('required').addClass('hidden');
			jQuery('#social_quiz_post_meta .social_questions').find('.sqa_text_answer').removeClass('hidden').addClass('required');
		} else if(value_type == 'image') {
			jQuery('#social_quiz_post_meta .social_questions').find('.sqa_text_answer').removeClass('required').addClass('hidden');
			jQuery('#social_quiz_post_meta .social_questions').find('.sqa_image_answer').removeClass('hidden').addClass('required');
		}
		
	});
	
	/*
		Function re arrange rows
	*/
	function sq_reset_rows(count) {
	choices = count;
		jQuery('table.social_questions tr.social_question_wrapper').each(function() {
			jQuery(this).find('input.field,textarea').each(function() {
				jQuery(this).attr('name', function() {this.name = this.name.replace(/[0-9]/, choices);});
			});
			jQuery('table.social_questions tr:last-child').find('input.button').each(function() {
				var next_btn = jQuery(this).attr('data-btn').replace(/[0-9]/, choices);
				jQuery(this).attr('data-btn', next_btn);
			});
			jQuery('table.social_questions tr:last-child').find('img.sqa_answer_preview').each(function() {
				var next_value = jQuery(this).attr('data-name').replace(/[0-9]/, choices);
				jQuery(this).parent().find('img.sqa_answer_preview').attr('data-name', next_value);
			});
			
			choices ++;
		});
	}
	
	$.fn.serializeObject = function() {
	   var o = {};
	   var a = this.serializeArray();
	   $.each(a, function() {
		   if (o[this.name]) {
			   if (!o[this.name].push) {
				   o[this.name] = [o[this.name]];
			   }
			   o[this.name].push(this.value || '');
		   } else {
			   o[this.name] = this.value || '';
		   }
	   });
	   return o;
	};
	
	
})( jQuery );
